# Star Convex Bubble Finder

The present repository contains the code to identify and reconstruct overlapping bubbles in 2D images as described in

- H. Hessenkemper, S. Starke, Y. Atassi, T. Ziegenhein, D. Lucas 
Bubble identification from images with machine learning methods. *Submitted to International Journal of Multiphase Flows*

It is based on the [*StarDist*](https://github.com/stardist/stardist) approach to predict star-convex polygons as object representation in crowded images. Further optional improvements can be achieved with a object mask provided by a *UNet* and a correction of the occluded bubble parts with a so-called *Radial Distance Correction*. For applying these three models, pretrained models can be downloaded at [...] ()

## Installation

The code is compatible with python version 3.7. Please install the required packages using conda with the following procedure. At first, the packages listed in the requirements.txt file can be installed using `pip`

> pip install -r requirements.txt

Afterwards install mxnet using either the GPU enabled version (**recommended**)

> pip install mxnet-cu101==1.5.0

if you have a CUDA compatible GPU or the corresponding CPU version

> pip install mxnet==1.5.0

if you can not use GPU. For Linux also newer mxnet version are possible. Then the correct numpy version needs to be installed with

> pip install numpy==1.20.0

Ignore all incoming warnings.

## Usage

After installation the demonstration Prediction_demo.ipynb notebook can be directly used to identify and reconstruct overlapping bubbles in images. 

If you have any questions, please contact h.hessenkemper@hzdr.de
